// This is my first gnome-shell extension, so it's pretty bare.
// I used  Week Clock Extension as a skeleton for some functions, credit to
// Afriskito ( http://afriskito.net/Gnome3Extensions/Week_Clock/ ).
// This will change the default clock in order to show the currect time, 
// numerical date and week day, using the format: HH:MM:SS YYYY/mm/DD, day

const St = imports.gi.St;
const Main = imports.ui.main;
const Mainloop = imports.mainloop;
const Lang = imports.lang;
const gio = imports.gi.Gio;

const UPDATE_INTERVAL = 1000; // every second

function FullClock() {
    this._init();
}

FullClock.prototype = {
    _init: function() {
        // Original clock:
        this.date_menu = Main.panel._dateMenu;
        this.orig_clock = this.date_menu._clock;
        // New clock:
        this.full_clock = new St.BoxLayout();
        this.full_time = new St.Label({ style_class: 'my_time' });
        this.full_date = new St.Label({ style_class: 'my_date' });
        this.full_day = new St.Label({ style_class: 'my_today' });
        this.full_clock.add(this.full_time);
        this.full_clock.add(this.full_date);
        this.full_clock.add(this.full_day);

        this.timeout = null;
    },

    MakeClock: function() {

        now = new Date();
        check_options = new gio.Settings({schema: "org.gnome.desktop.interface"});

        // Check if date should be displayed:
        if ( check_options.get_boolean("clock-show-date") == true ) {
            // Get date:
            year = now.getFullYear();
            month = ( now.getMonth() + 1 );
            if ( month < 10 ) {
                month = "0"+month;
            }
            day = now.getDate();
            if ( day < 10 ) {
                day = "0"+day;
            }
            my_date = year+"/"+month+"/"+day+", ";

            // Get the day's name:
            days = ["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];
            my_today = days[now.getDay()];
        } else {
            my_date = ""
            my_today = ""
        }

        // Get time:
        hours = now.getHours();
        /*
        if ( hours < 10 ) {
            hours = "0"+hours;
        }
        */
        minutes = now.getMinutes();
        if ( minutes < 10 ) {
            minutes = "0"+minutes;
        }
        // Check if seconds should be displayed:
        if ( check_options.get_boolean("clock-show-seconds") == true ) {
            seconds = now.getSeconds();
            if ( seconds < 10 ) {
                seconds = "0"+seconds;
            }
            my_time = hours+":"+minutes+":"+seconds+" ";
        } else {
            my_time = hours+":"+minutes+" ";
        }

        // Set labels:
        this.full_time.set_text(my_time);
        this.full_date.set_text(my_date);
        this.full_day.set_text(my_today);
    },

    on_timeout: function() {
        this.MakeClock();
        return this.run;
    },

    enable: function() {
        this.date_menu.actor.remove_actor(this.orig_clock);
        this.date_menu.actor.add_actor(this.full_clock);
        this.run = true;

        this.on_timeout();
        this.timeout = Mainloop.timeout_add(UPDATE_INTERVAL, Lang.bind(this, this.on_timeout));
    },

    disable: function() {
        this.run = false;
        MainLoop.source_remove(this.timeout);

        this.date_menu.actor.remove_actor(this.full_clock);
        this.date_menu.actor.add_actor(this.orig_clock);
    }
}       

function init() {
    return new FullClock();
}
